<?php
/**
 *
 * Random Banner Scroll. An extension for the phpBB Forum Software package.
 *
 * @copyright (c) 2017, Galandas, http://phpbb3world.altervista.org
 * @license GNU General Public License, version 2 (GPL-2.0)
 *
 */

namespace galandas\bannerscroll\acp;

/**
 * Banner Scroll ACP module.
 */
class banner_scroll_module
{
	public $u_action;
	protected $action;
	protected $table;
	
	public function main ($id, $mode)
	{
		global $config, $db, $user, $template, $request, $table_prefix;
		
		$this->table = $table_prefix . 'banner';
		
		$this->tpl_name = 'acp_banner_scroll';
		$this->page_title = $user->lang('BANNER_SCROLL_TITLE');
		add_form_key('acp_banner_scroll');

		$sql = 'SELECT *
            FROM ' . $this->table . '
            ORDER BY banner_id ASC';
        $result = $db->sql_query($sql);
        while( $row = $db->sql_fetchrow($result) )
		{
			$template->assign_block_vars('scroll', array(
				'B_ID'			    => $row['banner_id'],
				'B_NAME'			=> $row['banner_name'],
				'B_URL'			    => $row['banner_url'],
				'B_IMAGE'			=> $row['banner_image'],
				'U_EDIT'			=> $this->u_action . "&amp;id=" . $row['banner_id'] . "&amp;action=edit",
				'U_DELETE'			=> $this->u_action . "&amp;id=" . $row['banner_id'] . "&amp;action=delete"
			));
		}
		$db->sql_freeresult($result);

		$template->assign_vars(array(
			'S_BANNER_SCROLL_ENABLED'   => $config['banner_scroll_enable'],
			'BANNER_VERSION'			=> $config['banner_scroll_version']	
		));

		$submit = $request->is_set_post('submit');
        $enable_submit = $request->is_set_post('enable_submit');
		
		$edit_id = $request->variable('edit', 0);
		
		$enabled = $request->variable('enable_banner_scroll', 0);
		
		if ($submit && !check_form_key('acp_banner_scroll') && !$edit_id)
		{
			trigger_error($user->lang['FORM_INVALID']);
		}
		if ($enable_submit && !check_form_key('acp_banner_scroll'))
		{
			trigger_error($user->lang['FORM_INVALID']);
		}
		
		if ($submit)
		{
			$name = $request->variable('name', '', true);
			$url = $request->variable('url', '');
			$image = $request->variable('image', '');

			if($name != '' && $url != '' && $image != '' && !$edit_id)
			{
				$sql_array = array(
					'banner_name'		=> $name,
					'banner_url'		=> $url,
					'banner_image'		=> $image
				);

				$sql = 'INSERT INTO ' . $this->table . ' ' . $db->sql_build_array('INSERT', $sql_array);
				$db->sql_query($sql);
				trigger_error($user->lang['BANNER_SCROLL_ADDED'] . adm_back_link($this->u_action));
			}
			else if($name != '' && $url != '' && $image != '' && !empty($edit_id))
			{
				$sql_array = array(
				'banner_name'		    => $name,
				'banner_url'		    => $url,
				'banner_image'		    => $image
				);

				$sql = 'UPDATE ' . $this->table . ' SET ' . $db->sql_build_array('UPDATE', $sql_array) . ' WHERE banner_id = ' . $edit_id;
				$db->sql_query($sql);
				trigger_error($user->lang['BANNER_SCROLL_UDPATED'] . adm_back_link($this->u_action));
			}
			else
			{
				trigger_error($user->lang['BANNER_SCROLL_ERROR'] . adm_back_link($this->u_action . '&amp;action=add'), E_USER_WARNING);
			}
		}
		
		if ($enable_submit)
		{
		  $config->set('banner_scroll_enable', $enabled);
			trigger_error($user->lang['BANNER_SCROLL_CONF_UDPATED'] . adm_back_link($this->u_action));
		}

		$action = $request->variable('action', '');
		$id_banner = $request->variable('id', 0);
		if($action && $id_banner != 0)
		{
			$action = $request->variable('action', '');
			switch ($action)
			{
				case 'edit':
					$sql = 'SELECT *
						FROM ' . $this->table . '
						WHERE banner_id = ' . $id_banner;
					$result = $db->sql_query($sql);
					$row = $db->sql_fetchrow($result);
					$template->assign_vars(array(
						'B_NAME'			=> $row['banner_name'],
						'B_URL'			    => $row['banner_url'],
						'B_IMAGE'			=> $row['banner_image'],
						'B_EDIT'			=> $row['banner_id'],
					));
					$db->sql_freeresult($result);
				break;
				case 'delete':
					if (confirm_box(true))
					{
						$sql = 'DELETE FROM
							' . $this->table . '
							WHERE banner_id = ' . $id_banner;
						$db->sql_query($sql);
						redirect($this->u_action);
					}
					else
					{
						confirm_box(false, $user->lang['CONFIRM_OPERATION'], build_hidden_fields(array(
							'action'		=> $action,
							'id'	        => $id_banner))
						);
					}
				break;
			}
		}
	}
}