<?php
/**
 *
 * Random Banner Scroll. An extension for the phpBB Forum Software package.
 *
 * @copyright (c) 2017, Galandas, http://phpbb3world.altervista.org
 * @license GNU General Public License, version 2 (GPL-2.0)
 *
 */

namespace galandas\bannerscroll\migrations;

class install_rbs extends \phpbb\db\migration\migration
{
	static public function depends_on()
	{
		return array('\phpbb\db\migration\data\v31x\v314');
	}
	
	public function update_schema()
	{
		return array(
			'add_tables'	=> array(
				$this->table_prefix . 'banner'	=> array(
					'COLUMNS'	=> array(
						'banner_id'			=> array('TINT:8', null, 'auto_increment'),
						'banner_name'		=> array('VCHAR', ''),
						'banner_url'		=> array('VCHAR', ''),
						'banner_image'	    => array('VCHAR', ''),
					),
					'PRIMARY_KEY'	=> 'banner_id',
				),
			),
		);
	}
	
	public function revert_schema()
	{
		return 	array(
			'drop_tables' => array(
				$this->table_prefix . 'banner',
			),
		);
	}

	public function update_data()
	{
		return array(

			// Add configs
			array('config.add', array('banner_scroll_enable', 0)),
			array('config.add', array('banner_scroll_version', '1.0.4')),
			// Add permission
			array('permission.add', array('a_rbs', true)),
			// Set permissions
			array('permission.permission_set', array('ROLE_ADMIN_FULL', 'a_rbs')),
			// Add ACP module
			array('module.add', array(
				'acp',
				'ACP_CAT_DOT_MODS',
				'BANNER_SCROLL_TITLE'
			)),
			array('module.add', array(
				'acp',
				'BANNER_SCROLL_TITLE',
				array(
					'module_basename'	=> '\galandas\bannerscroll\acp\banner_scroll_module',
					'modes' => array('settings'),
				),
			)),
			array('custom', array(array($this, 'add_default_values'))),			
		);
	}	

	public function add_default_values()
	{
		$data	 =	array(
				array(
					"banner_id"			=> 1,
					"banner_name"		=> "Random Banner Scroll",
					"banner_image"		=> generate_board_url() . '/ext/galandas/bannerscroll/styles/prosilver/theme/images/banner/rbs.png',					
					"banner_url"		=> "http://phpbb3world.altervista.org/",
				),
				array(
					"banner_id"			=> 2,
					"banner_name"		=> "Prototype Banner Dimensions",
					"banner_image"		=> generate_board_url() . '/ext/galandas/bannerscroll/styles/prosilver/theme/images/banner/pixel.gif',					
					"banner_url"		=> "http://phpbb3world.altervista.org/",
				),
		);

		foreach ($data as $row )
		{
			$query = 'INSERT INTO ' . $this->table_prefix . 'banner' . ' ' . $this->db->sql_build_array('INSERT', $row);
			
			$this->db->sql_query($query);
		}
	}	

}
